/* defines.h
 * a bunch of practical defines and global constants
 */
#ifndef DEFINES_H
#define DEFINES_H
#include <ggi/ggi.h>

#define MAX( x, y ) (x) > (y) ? (x) : (y)
#define MIN( x, y ) (x) < (y) ? (x) : (y)

#define AFTERLIFE 1
#define EVENTS 25
#define MAXDATA (255-3)


typedef struct MG_packet{
	uint8   private;        /* used for operations on the command */
	uint8   size;           /* size of event in bytes       */
	uint8   type;           /* type of this event           */
	unsigned char    data[MAXDATA];  /* command related data         */
}MG_packet;

typedef struct _communication{
	int socket;
	int read;
	int sent;
	MG_packet packet;
	MG_packet out;
} communication;


typedef struct _region{
  struct _region *next;
  int x,y,w,h;
} region;


typedef struct _events{
	int last;
	ggi_event buffer[EVENTS];
	ggi_event_mask mask;
	ggi_event_mask poll_mask;
	ggi_event_mask read_mask;
}eventinfo;


#endif
