/* event.h
 * event management for the display server
 */
#ifndef EVENT_H
#define EVENT_H

#include "mgwinlib.h"
#include "client.h"
#include <ggi/ggi.h>

void set_eventmask( ); // set global eventmask;

void store_event( client *c, gii_event *ev );
void get_event( client *c, gii_event *ev);
gii_event_mask scan_events(client *c, gii_event_mask mask );

void dispatch_event( client *c, gii_event *ev);
void process_events( fd_set *read_set);

void broadcast_focus_event(int new, int lost);
void send_resize_event(client *c );
void send_move_event(client *c, int x, int y);
void send_mouse_event(client *c, int direction);
int get_winmgevent(gii_event *event, winmg_event *ev);

#endif
