/* init.c
 * MG server
 *
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "schedule.h"
#include <signal.h>

typedef void Sigfunc(int);

Sigfunc *mysignal(int signo, Sigfunc *func)
{
	struct sigaction act, oact;
	act.sa_handler = func;
	sigemptyset( &act.sa_mask );
	act.sa_flags = 0;
	if( sigaction(signo, &act, &oact) < 0 )
		return (SIG_ERR);
	return (oact.sa_handler);
}

void debug_signal( int signo )
{
	fprintf(stderr, "signal of type %d received\n", signo);
	fflush(stderr);
	return;
}


// grab console and redirect i/o
void init_system( void )
{
	init_scheduler();
//	mysignal( SIGHUP, debug_signal );    //1
//	mysignal( SIGINT, debug_signal );    //2
//	mysignal( SIGQUIT, debug_signal );   //3
//	mysignal( SIGILL, debug_signal );    //4
//	mysignal( SIGTRAP, debug_signal );
//	mysignal( SIGABRT, debug_signal );
//	mysignal( SIGIOT, debug_signal );
//	mysignal( SIGBUS, debug_signal );
//	mysignal( SIGFPE, debug_signal );
//	mysignal( SIGKILL, debug_signal );
//	mysignal( SIGUSR1, debug_signal );
//	mysignal( SIGSEGV, debug_signal );
//	mysignal( SIGUSR2, debug_signal );
	mysignal( SIGPIPE, debug_signal );
//	mysignal( SIGALRM, debug_signal );
//	mysignal( SIGTERM, debug_signal );
//	mysignal( SIGSTKFLT, debug_signal );
//	mysignal( SIGCHLD, debug_signal );
//	mysignal( SIGCONT, debug_signal );
//	mysignal( SIGSTOP, debug_signal );
//	mysignal( SIGTSTP, debug_signal );
//	mysignal( SIGTTIN, debug_signal );
//	mysignal( SIGTTOU, debug_signal );
//	mysignal( SIGURG, debug_signal );
//	mysignal( SIGXCPU, debug_signal );
//	mysignal( SIGXFSZ, debug_signal );
//	mysignal( SIGVTALRM, debug_signal );
//	mysignal( SIGPROF, debug_signal );
//	mysignal( SIGWINCH, debug_signal );
//	mysignal( SIGIO, debug_signal );
//	mysignal( SIGPWR, debug_signal );
//	mysignal( SIGUNUSED, debug_signal );
}



void run_startscript( void )
{
	int child;
	char *startscript = "./startup";

	if( (child = fork()) == -1 ){
		printf("fork error\n");
		return;
	}
	if( child != 0 ){
		return;
	} else {
		char *argv[] = { NULL, NULL };
		argv[0] = startscript;
		
		// now we are the child!
		sleep(3);		
		setenv("GGI_DISPLAY", "yaws", 1);
		execv( argv[0], argv );		
	}
}

