/* regions.h
 * MG server
 *
 */

#include "defines.h"
#ifndef REGIONS_H
#define REGIONS_H

int in_region( int x, int y, region *r );
void order( region **list, int dx, int dy );
void translate( region *list, int dx, int dy );
region *find_region( region *list, int x, int y, int w, int h );
region *duplicate( region *source );
void print_regions( region *list );
region *remove_region( region **list, region *r );
void add_region( region **list, region *r );
region *create_region( int x, int y, int w, int h );
int destroy_region( region *r );
void destroy_regions( region **r );
region *intersect_single(region *a, region *b);
region *intersect( region *a, region *b );
region *join( region *a, region *b );
int joinable( region *a, region *b );
void grow( region **list, region *new );
int covers( region *a, region *b );
region *difference_single( region *list, region *mask );
region *difference( region *list, region *masks );

#endif
