/* visual.c
 * MG server
 *
 */

#include "network.h"
#include "decor.h"
#include "client.h"
#include "event.h"
#include "windows.h"
#include "regions.h"
#include <ggi/ggi.h>
#include <stdlib.h>

static ggi_visual_t vis;
static ggi_mode mode;
region display;

region *get_screen( void )
{
	return &display;
}

int screen_width( void )
{
	return mode.visible.x;
}

int screen_height( void )
{
	return mode.visible.y;
}

void init_display( void )
{
//	int i;
	ggi_color color;
	ggi_pixel pix;
	if (ggiInit() != 0) {
		fprintf(stderr, "unable to initialize libggi, exiting.\n");
		exit(1);
	}
	if ((vis=ggiOpen(NULL)) == NULL) {
		ggiPanic("unable to open default visual, exiting.\n");
	}
	
	ggiSetFlags(vis, GGIFLAG_ASYNC);
	if (ggiSetGraphMode(vis, GGI_AUTO, GGI_AUTO, 
			    GGI_AUTO, GGI_AUTO , GGI_AUTO) != 0) {
		ggiPanic("Cannot set default mode!\n");
	}
	
	ggiGetMode(vis, &mode);
	display.x = display.y = 0;
	display.w = screen_width();
	display.h = screen_height();

// this refers to the function in decor.c
	init_palette(vis);

/*	if (GT_SCHEME(mode.graphtype) == GT_PALETTE) {
		
		int nocols = 1 << GT_DEPTH(mode.graphtype);
		
		ggi_color Palette[256];
		
		for (i = 0; i < nocols; i++) {
			Palette[i].r = i*0xffff/(nocols-1);
			Palette[i].g = i*0xffff/(nocols-1);
			Palette[i].b = i*0xffff/(nocols-1);
		}
		
		ggiSetPalette(vis, 0, nocols, Palette);
	}
*/
	color.r = color.g = color.b = color.a = 0;
	pix = ggiMapColor( vis, &color );
	set_fillcolor(pix);
	ggiSetGCForeground(vis, pix);
	ggiFillscreen(vis);
}

ggi_visual_t target_visual()
{
  return vis;
} 





