/* windows.h
 * MG server
 *
 * Handles positioning and resizing of windows
 *
 */
#ifndef WINDOWS_H
#define WINDOWS_H

#include "mgwinlib.h"
#include "client.h"
#include <ggi/ggi.h>

typedef struct { 
  int x, y, z, wheel; 
} pointer_position;




// return max size for windows
int max_width(client *);
int max_height(client *);
//returns set size for windows
int env_width(client *);
int env_height(client *);
void set_fillcolor( ggi_pixel col );
void redraw_region( client *c, region *r);
void update_regions( region *r );
void reshape_window( client *c, ggi_mode *mode );
void move_window(client *c, int dx, int dy);
void change_window( client *c, int x, int y, int w, int h );

void redraw_screen_area( region *r );
void redraw_screen( );
void redraw_window( client *c );

void get_pointer(pointer_position *pos);
pointer_position *get_position( void );

void pointer_move( int x, int y, int z, int wheel);
void PtrButtonPressed( unsigned int button );
void PtrButtonReleased( unsigned int button );

int menu_active( void );
void deactivate_menu( void );

void lock_windows( void );
void unlock_windows( void );


client *get_focus();
client *get_window( pointer_position *pos);
client *moving();
client *resizing();
client *drawing( void );
void set_moving(client *c);

#define FOLLOW_MOUSE 0
#define LAZY 1
#define CLICK 2

client *curwin( void );
int focus_policy( void );
void set_focus(client *c);
int in_active( client *c, pointer_position *pos );
int on_tab( client *c, pointer_position *pos );
int on_evtarget( void);
int click_interval();
int autoraise();
void update_focus( void );
void execute_winmg_command( client *c, winmg_cmd *cmd );

#endif



